# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from pal_walking_msgs/SMStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class SMStatus(genpy.Message):
  _md5sum = "c7b8f29539d1ef0f23de0a00992a911c"
  _type = "pal_walking_msgs/SMStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """geometry_msgs/Pose left_foot_pose
geometry_msgs/Pose right_foot_pose
uint8 stance_foot_side

geometry_msgs/Pose future_swing_landing_pose
uint8 future_swing_side

uint8 right=1               # right leg constant
uint8 left=0                # left leg constant

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  # Pseudo-constants
  right = 1
  left = 0

  __slots__ = ['left_foot_pose','right_foot_pose','stance_foot_side','future_swing_landing_pose','future_swing_side']
  _slot_types = ['geometry_msgs/Pose','geometry_msgs/Pose','uint8','geometry_msgs/Pose','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       left_foot_pose,right_foot_pose,stance_foot_side,future_swing_landing_pose,future_swing_side

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SMStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.left_foot_pose is None:
        self.left_foot_pose = geometry_msgs.msg.Pose()
      if self.right_foot_pose is None:
        self.right_foot_pose = geometry_msgs.msg.Pose()
      if self.stance_foot_side is None:
        self.stance_foot_side = 0
      if self.future_swing_landing_pose is None:
        self.future_swing_landing_pose = geometry_msgs.msg.Pose()
      if self.future_swing_side is None:
        self.future_swing_side = 0
    else:
      self.left_foot_pose = geometry_msgs.msg.Pose()
      self.right_foot_pose = geometry_msgs.msg.Pose()
      self.stance_foot_side = 0
      self.future_swing_landing_pose = geometry_msgs.msg.Pose()
      self.future_swing_side = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_14dB7dB().pack(_x.left_foot_pose.position.x, _x.left_foot_pose.position.y, _x.left_foot_pose.position.z, _x.left_foot_pose.orientation.x, _x.left_foot_pose.orientation.y, _x.left_foot_pose.orientation.z, _x.left_foot_pose.orientation.w, _x.right_foot_pose.position.x, _x.right_foot_pose.position.y, _x.right_foot_pose.position.z, _x.right_foot_pose.orientation.x, _x.right_foot_pose.orientation.y, _x.right_foot_pose.orientation.z, _x.right_foot_pose.orientation.w, _x.stance_foot_side, _x.future_swing_landing_pose.position.x, _x.future_swing_landing_pose.position.y, _x.future_swing_landing_pose.position.z, _x.future_swing_landing_pose.orientation.x, _x.future_swing_landing_pose.orientation.y, _x.future_swing_landing_pose.orientation.z, _x.future_swing_landing_pose.orientation.w, _x.future_swing_side))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.left_foot_pose is None:
        self.left_foot_pose = geometry_msgs.msg.Pose()
      if self.right_foot_pose is None:
        self.right_foot_pose = geometry_msgs.msg.Pose()
      if self.future_swing_landing_pose is None:
        self.future_swing_landing_pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 170
      (_x.left_foot_pose.position.x, _x.left_foot_pose.position.y, _x.left_foot_pose.position.z, _x.left_foot_pose.orientation.x, _x.left_foot_pose.orientation.y, _x.left_foot_pose.orientation.z, _x.left_foot_pose.orientation.w, _x.right_foot_pose.position.x, _x.right_foot_pose.position.y, _x.right_foot_pose.position.z, _x.right_foot_pose.orientation.x, _x.right_foot_pose.orientation.y, _x.right_foot_pose.orientation.z, _x.right_foot_pose.orientation.w, _x.stance_foot_side, _x.future_swing_landing_pose.position.x, _x.future_swing_landing_pose.position.y, _x.future_swing_landing_pose.position.z, _x.future_swing_landing_pose.orientation.x, _x.future_swing_landing_pose.orientation.y, _x.future_swing_landing_pose.orientation.z, _x.future_swing_landing_pose.orientation.w, _x.future_swing_side,) = _get_struct_14dB7dB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_14dB7dB().pack(_x.left_foot_pose.position.x, _x.left_foot_pose.position.y, _x.left_foot_pose.position.z, _x.left_foot_pose.orientation.x, _x.left_foot_pose.orientation.y, _x.left_foot_pose.orientation.z, _x.left_foot_pose.orientation.w, _x.right_foot_pose.position.x, _x.right_foot_pose.position.y, _x.right_foot_pose.position.z, _x.right_foot_pose.orientation.x, _x.right_foot_pose.orientation.y, _x.right_foot_pose.orientation.z, _x.right_foot_pose.orientation.w, _x.stance_foot_side, _x.future_swing_landing_pose.position.x, _x.future_swing_landing_pose.position.y, _x.future_swing_landing_pose.position.z, _x.future_swing_landing_pose.orientation.x, _x.future_swing_landing_pose.orientation.y, _x.future_swing_landing_pose.orientation.z, _x.future_swing_landing_pose.orientation.w, _x.future_swing_side))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.left_foot_pose is None:
        self.left_foot_pose = geometry_msgs.msg.Pose()
      if self.right_foot_pose is None:
        self.right_foot_pose = geometry_msgs.msg.Pose()
      if self.future_swing_landing_pose is None:
        self.future_swing_landing_pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 170
      (_x.left_foot_pose.position.x, _x.left_foot_pose.position.y, _x.left_foot_pose.position.z, _x.left_foot_pose.orientation.x, _x.left_foot_pose.orientation.y, _x.left_foot_pose.orientation.z, _x.left_foot_pose.orientation.w, _x.right_foot_pose.position.x, _x.right_foot_pose.position.y, _x.right_foot_pose.position.z, _x.right_foot_pose.orientation.x, _x.right_foot_pose.orientation.y, _x.right_foot_pose.orientation.z, _x.right_foot_pose.orientation.w, _x.stance_foot_side, _x.future_swing_landing_pose.position.x, _x.future_swing_landing_pose.position.y, _x.future_swing_landing_pose.position.z, _x.future_swing_landing_pose.orientation.x, _x.future_swing_landing_pose.orientation.y, _x.future_swing_landing_pose.orientation.z, _x.future_swing_landing_pose.orientation.w, _x.future_swing_side,) = _get_struct_14dB7dB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_14dB7dB = None
def _get_struct_14dB7dB():
    global _struct_14dB7dB
    if _struct_14dB7dB is None:
        _struct_14dB7dB = struct.Struct("<14dB7dB")
    return _struct_14dB7dB
